<template>

    <div>

        <div class="flex place-content-center mb-4">
            <h3 class="text-3xl">Create An Item</h3>
        </div>

        <div v-if="errors">
            <div v-for="(v, k) in errors" :key="k"
                 class="bg-red-500 text-white rounded font-bold mb-4 shadow-lg py-2 px-4 pr-0">
                <p v-for="error in v" :key="error" class="text-sm">
                    {{ error }}
                </p>
            </div>
        </div>

        <form class="space-y-6" @submit.prevent="saveCompany">
            <div class="space-y-4 rounded-md shadow-sm">
                <div>
                    <label for="name" class="block text-sm font-medium text-pink-400">Name</label>
                    <div class="mt-1">
                        <input type="text" name="name" id="name"
                               class="block mt-1 w-full rounded-md border-pink-400
                               shadow-sm focus:border-pink-600 focus:ring
                               focus:ring-indigo-200 focus:ring-opacity-50"
                               v-model="form.name">
                    </div>
                </div>

                <div>
                    <label for="email" class="block text-sm font-medium text-pink-400">Email</label>
                    <div class="mt-1">
                        <input type="text" name="email" id="email"
                               class="block mt-1 w-full rounded-md border-pink-400 shadow-sm focus:border-pink-600 focus:ring focus:ring-indigo-200 focus:ring-opacity-50"
                               v-model="form.email">
                    </div>
                </div>

                <div>
                    <label for="address" class="block text-sm font-medium text-pink-400">Address</label>
                    <div class="mt-1">
                        <input type="text" name="address" id="address"
                               class="block mt-1 w-full rounded-md border-pink-400 shadow-sm focus:border-pink-600 focus:ring focus:ring-indigo-200 focus:ring-opacity-50"
                               v-model="form.address">
                    </div>
                </div>

                <div>
                    <label for="website" class="block text-sm font-medium text-pink-400">Website</label>
                    <div class="mt-1">
                        <input type="text" name="website" id="website"
                               class="block mt-1 w-full rounded-md border-pink-400 shadow-sm focus:border-pink-600 focus:ring focus:ring-indigo-200 focus:ring-opacity-50"
                               v-model="form.website">
                    </div>
                </div>
            </div>

            <button type="submit"
                    class="inline-flex items-center px-4 py-2 text-xs font-semibold
                    tracking-widest text-white uppercase bg-pink-600 rounded-md
                    border border-transparent ring-gray-300 transition duration-150
                    ease-in-out hover:bg-pink-800 active:bg-pink-900 focus:outline-none
                    focus:border-gray-900 focus:ring disabled:opacity-25">
                Create
            </button>
        </form>
    </div>


    <div class="overflow-hidden overflow-x-auto min-w-full align-middle sm:rounded-md">

        <div class="flex place-content-center mb-4">
            <h3 class="text-3xl">List Of Items</h3>
        </div>

        <table class="min-w-full border divide-y divide-gray-200">
            <thead>
            <tr>
                <th class="px-6 py-3 bg-pink-200">
                    <span
                        class="text-xs font-medium tracking-wider leading-4 text-left text-gray-800 font-bold uppercase">Name</span>
                </th>
                <th class="px-6 py-3 bg-pink-200">
                    <span
                        class="text-xs font-medium tracking-wider leading-4 text-left text-gray-800 font-bold uppercase">Email</span>
                </th>
                <th class="px-6 py-3 bg-pink-200">
                    <span
                        class="text-xs font-medium tracking-wider leading-4 text-left text-gray-800 font-bold uppercase">Address</span>
                </th>
                <th class="px-6 py-3 bg-pink-200">
                    <span
                        class="text-xs font-medium tracking-wider leading-4 text-left text-gray-800 font-bold uppercase">Website</span>
                </th>
                <th class="px-6 py-3 bg-pink-200">
                </th>
            </tr>
            </thead>

            <tbody class="bg-white divide-y divide-gray-200 divide-solid">
            <template v-for="item in companies" :key="item.id">
                <tr class="bg-white hover:bg-pink-50">
                    <td class="px-6 py-4 text-sm leading-5 text-gray-900 whitespace-no-wrap">
                        {{ item.name }}
                    </td>
                    <td class="px-6 py-4 text-sm leading-5 text-gray-900 whitespace-no-wrap">
                        {{ item.email }}
                    </td>
                    <td class="px-6 py-4 text-sm leading-5 text-gray-900 whitespace-no-wrap">
                        {{ item.address }}
                    </td>
                    <td class="px-6 py-4 text-sm leading-5 text-gray-900 whitespace-no-wrap">
                        {{ item.website }}
                    </td>
                    <td class="px-6 py-4 text-sm leading-5 text-gray-900 whitespace-no-wrap">
                        <button @click="deleteCompany(item.id)"
                                class="inline-flex items-center px-4 py-2 text-xs font-semibold
                    tracking-widest text-white uppercase bg-pink-600 rounded-md
                    border border-transparent ring-gray-300 transition duration-150
                    ease-in-out hover:bg-pink-800 active:bg-pink-900 focus:outline-none
                    focus:border-gray-900 focus:ring disabled:opacity-25">
                            Delete
                        </button>
                    </td>
                </tr>
            </template>
            </tbody>
        </table>
    </div>


</template>


<script>
import {reactive} from "vue";
import useCompanies from "../../composables/companies";
import {onMounted} from "vue";

export default {
    setup() {
        const {companies, getCompanies, destroyCompany, errors, storeCompany} = useCompanies()

        onMounted(getCompanies)

        const deleteCompany = async (id) => {
            if (!window.confirm('Are you sure?')) {
                return
            }

            await destroyCompany(id);
            await getCompanies();
        }

        const form = reactive({
            'name': '',
            'email': '',
            'address': '',
            'website': '',
        })


        const saveCompany = async () => {

            const response = await storeCompany({...form});

            if (response === true) {
                form.name = '';
                form.email = '';
                form.website = '';
                form.address = '';
                await getCompanies();
            }

        }

        return {
            companies,
            deleteCompany,
            form,
            errors,
            saveCompany
        }
    }
}
</script>
